wxWidgets: wxAnimation Class Reference

| Version: 3.2.6

Public Member Functions | Static Public Member Functions | List of all members
wxAnimation Class Reference

`#include <wx/animate.h>`

Inheritance diagram for wxAnimation:
[legend]

## Detailed Description

The `wxAnimation` class handles the interface between the animation control and the details of the animation image or data.

Predefined objects/pointers: wxNullAnimation

See also
  wxAnimationCtrl, Animation Sample

## Public Member Functions
| wxAnimation ()
| Constructs a new empty animation object. More...
| wxAnimation (const wxString &name, wxAnimationType type=wxANIMATION_TYPE_ANY)
| Constructs a new animation object and load the animation data from the given filename. More...
| wxAnimation (const wxAnimation &other)
| Copy constructor. More...
bool | IsOk () const
| Returns true if animation data is present. More...
bool | IsCompatibleWith (wxClassInfo *ci) const
| Returns true if animation can be used with controls of the given type. More...
int | GetDelay (unsigned int frame) const
| Returns the delay for the i-th frame in milliseconds. More...
unsigned int | GetFrameCount () const
| Returns the number of frames for this animation. More...
wxImage | GetFrame (unsigned int frame) const
| Returns the i-th frame as a wxImage. More...
wxSize | GetSize () const
| Returns the size of the animation. More...
bool | LoadFile (const wxString &name, wxAnimationType type=wxANIMATION_TYPE_ANY)
| Loads an animation from a file. More...
bool | Load (wxInputStream &stream, wxAnimationType type=wxANIMATION_TYPE_ANY)
| Loads an animation from the given stream. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Static Public Member Functions
static wxAnimationDecoderList & | GetHandlers ()
| Returns the list of animation decoders used by the generic animation and `wxGenericAnimationCtrl`. More...
static void | AddHandler (wxAnimationDecoder *handler)
| Add a new decoder to the list of animation decoders. More...
static void | InsertHandler (wxAnimationDecoder *handler)
| Insert a new decoder to the front of the list of animation decoders. More...
static const wxAnimationDecoder * | FindHandler (wxAnimationType animType)
| Search for an animation decoder by type. More...
static void | InitStandardHandlers ()
| Load the stock animation decoders (currently GIF and ANI) into the list of decoders. More...
static void | CleanUpHandlers ()
| Clear out the animation decoder list. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxAnimation() [1/3]

wxAnimation::wxAnimation | ( |  | ) |

Constructs a new empty animation object.

Call Load() to initialize it.

See also
  wxAnimationCtrl::CreateAnimation()

## ◆ wxAnimation() [2/3]

wxAnimation::wxAnimation | ( | const wxString & | name,
|  | wxAnimationType | type = `wxANIMATION_TYPE_ANY`
| ) |  |

Constructs a new animation object and load the animation data from the given filename.

Parameters

  name | A filename.
  type | One of the wxAnimationType values; wxANIMATION_TYPE_ANY means that the function should try to autodetect the filetype.

See also
  wxAnimationCtrl::CreateAnimation()

## ◆ wxAnimation() [3/3]

wxAnimation::wxAnimation | ( | const wxAnimation & | other | ) |

Copy constructor.

## Member Function Documentation

## ◆ AddHandler()

static void wxAnimation::AddHandler | ( | wxAnimationDecoder * | handler | ) |
| static

Add a new decoder to the list of animation decoders.

## ◆ CleanUpHandlers()

static void wxAnimation::CleanUpHandlers | ( |  | ) |
| static

Clear out the animation decoder list.

This is called automatically at program shutdown.

## ◆ FindHandler()

static const wxAnimationDecoder* wxAnimation::FindHandler | ( | wxAnimationType | animType | ) |
| static

Search for an animation decoder by type.

## ◆ GetDelay()

int wxAnimation::GetDelay | ( | unsigned int | frame | ) | const

Returns the delay for the i-th frame in milliseconds.

If `-1` is returned the frame is to be displayed forever.

## ◆ GetFrame()

wxImage wxAnimation::GetFrame | ( | unsigned int | frame | ) | const

Returns the i-th frame as a wxImage.

This method is not implemented in the native wxGTK implementation of this class and always returns an invalid image there.

## ◆ GetFrameCount()

unsigned int wxAnimation::GetFrameCount | ( |  | ) | const

Returns the number of frames for this animation.

This method is not implemented in the native wxGTK implementation of this class and always returns 0 there.

## ◆ GetHandlers()

static wxAnimationDecoderList& wxAnimation::GetHandlers | ( |  | ) |
| inlinestatic

Returns the list of animation decoders used by the generic animation and `wxGenericAnimationCtrl`.

## ◆ GetSize()

wxSize wxAnimation::GetSize | ( |  | ) | const

Returns the size of the animation.

## ◆ InitStandardHandlers()

static void wxAnimation::InitStandardHandlers | ( |  | ) |
| static

Load the stock animation decoders (currently GIF and ANI) into the list of decoders.

This is called automatically at program startup.

## ◆ InsertHandler()

static void wxAnimation::InsertHandler | ( | wxAnimationDecoder * | handler | ) |
| static

Insert a new decoder to the front of the list of animation decoders.

## ◆ IsCompatibleWith()

bool wxAnimation::IsCompatibleWith | ( | wxClassInfo * | ci | ) | const

Returns true if animation can be used with controls of the given type.

This function checks if this animation object can be used with wxAnimationCtrl of particular type. This will be always the case for the platforms where only a single wxAnimationCtrl implementation is available, but not necessarily under e.g. wxGTK where both native (but limited) GTK implementation and generic implementation can be used.

Since
  3.1.4

## ◆ IsOk()

bool wxAnimation::IsOk | ( |  | ) | const

Returns true if animation data is present.

## ◆ Load()

bool wxAnimation::Load | ( | wxInputStream & | stream,
|  | wxAnimationType | type = `wxANIMATION_TYPE_ANY`
| ) |  |

Loads an animation from the given stream.

Parameters

  stream | The stream to use to load the animation. Under wxGTK may be any kind of stream; under other platforms this must be a seekable stream.
  type | One of the wxAnimationType enumeration values.

Returns
  true if the operation succeeded, false otherwise.

## ◆ LoadFile()

bool wxAnimation::LoadFile | ( | const wxString & | name,
|  | wxAnimationType | type = `wxANIMATION_TYPE_ANY`
| ) |  |

Loads an animation from a file.

Parameters

  name | A filename.
  type | One of the wxAnimationType values; wxANIMATION_TYPE_ANY means that the function should try to autodetect the filetype.

Returns
  true if the operation succeeded, false otherwise.